package org.zeroturnaround.javarebel.integration.jetty;

import org.zeroturnaround.bundled.javassist.CannotCompileException;
import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>org.eclipse.jetty.webapp.WebAppClassLoader</code>.
 * 
 * @author Rein Raudjärv
 */
public class EclipseJettyWebappClassLoaderCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    cp.importPackage("org.zeroturnaround.javarebel");

    processReinit(cp, ctClass);
  }

  private void processReinit(ClassPool cp, CtClass ctClass) throws CannotCompileException {
    try {
      ctClass.getDeclaredMethod("addClassPath").insertAfter(
          "{" +
          "  IntegrationFactory.getInstance().reinitializeClassLoader($0);" +
          "}");
    } catch (NotFoundException e) {
    }
    try {
      ctClass.getDeclaredMethod("addJars").insertAfter(
          "{" +
          "  IntegrationFactory.getInstance().reinitializeClassLoader($0);" +
          "}");
    } catch (NotFoundException e) {
    }
  }

}
