package org.zeroturnaround.javarebel.integration.resin;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>com.caucho.loader.SystemClassLoader</code>.
 * 
 * <p>Since Resin 3.1.x.</p>
 * 
 * @author Rein Raudjärv
 */
public class ResinSystemClassLoaderCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    cp.importPackage("org.zeroturnaround.javarebel");
    cp.importPackage("org.zeroturnaround.javarebel.integration.resin");
    
    ctClass.makeClassInitializer().insertAfter("ResinPatchHelper.setEnabled();");

    try {
      ctClass.getDeclaredMethod("loadClassImpl").insertBefore(
          "{ synchronized ($0) {" + 
          "    Class result =" + 
          "      findLoadedClass($1);" + 
          "    if (result != null)" + 
          "      return result;" + 
          "    result = " + 
          "      IntegrationFactory.getInstance().findReloadableClass($0, $1);" + 
          "    if (result != null)" + 
          "      return result;" + 
      "}}");
    } catch (NotFoundException e) {
      // Resin 3.1.x or earlier does not have this method
    }
  }
}
