package org.zeroturnaround.javarebel.integration.weblogic;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>weblogic.ejb.spi.EJBJar</code>.
 * 
 * @author Rein Raudjärv
 */
public class EJBJarCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    cp.importPackage("java.io");
    cp.importPackage("org.zeroturnaround.javarebel");

    ctClass.getDeclaredConstructor(cp.get(
        new String[] { "java.lang.String", "java.io.File" })).insertBefore(
            "{" +
            "  try {" +
            "    Logger log = LoggerFactory.getInstance();" +
            "    if (log.isEnabled()) {" +
            "       log.log(\"weblogic.ejb.spi.EJBJar(\" + $1 + \", \" + $2 + \")\");" +
            "    }" +

            "    ApplicationIntegrationFactory.getInstance().registerApplication($2);" +
            "  } catch (Throwable t) {" +
            "    LoggerFactory.getInstance().error(t);" +
            "  }" +
            "}"
        );
    
    ctClass.getDeclaredConstructor(cp.get(
        new String[] { "java.lang.String", "weblogic.application.ApplicationContextInternal" })).insertBefore(
            "{" +
            "  try {" +
            "    Logger log = LoggerFactory.getInstance();" +
            "    if (log.isEnabled()) {" +
            "       log.log(\"weblogic.ejb.spi.EJBJar(\" + $1 + \", \" + $2 + \")\");" +
            "    }" +

            "    File jar = null;" +
            "    weblogic.application.io.Ear ear = $2.getEar();" +
            "    if (ear == null) {" +
            "      jar = new File($2.getStagingPath());" +
            "    } else {" +
            "      File[] roots = ear.getModuleRoots($1);" +
            "      if (roots.length > 0) {" +
            "        jar = roots[0];" +
            "      }" +
            "    }" +

            "    if (jar != null) {" +
            "      ApplicationIntegrationFactory.getInstance().registerApplication(jar);" +
            "    }" +
            "  } catch (Throwable t) {" +
            "    LoggerFactory.getInstance().error(t);" +
            "  }" +
            "}"
        );
  }
}
