package org.zeroturnaround.javarebel.integration.weblogic;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>weblogic.application.io.Ear</code>.
 * 
 * @author Rein Raudjärv
 */
public class EarCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    cp.importPackage("org.zeroturnaround.javarebel");
    
    ctClass.getDeclaredConstructor(cp.get(
        new String[] { "java.lang.String", "java.io.File", "java.io.File" })).insertAfter(
        "{" +
        "  Logger log =  LoggerFactory.getInstance();" +
        "  if (log.isEnabled()) {" +
        "     log.log(\"weblogic.application.io.Ear(\" + $1 + \", \" + $2 + \", \" + $3 + \")\");" +
        "  }" +

        "  ApplicationIntegrationFactory.getInstance().registerApplication($2);" +
        "}"
        );
  }
}
