package org.zeroturnaround.javarebel.integration.weblogic;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.generic.FindClassClassBytecodeProcessor;

/**
 * Transforms <code>weblogic.utils.classloaders.GenericClassLoader</code>.
 * 
 * @author Rein Raudjärv
 */
public class GenericClassLoaderCBP extends FindClassClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    super.process(cp, cl, ctClass);
    
    cp.importPackage("org.zeroturnaround.javarebel");
    
    try {
      ctClass.getDeclaredMethod("addClassFinder").insertAfter(
          "{ " + 
          "  IntegrationFactory.getInstance().reinitializeClassLoader($0);" +
          "}");
    } catch (NotFoundException e) { /* skip */ }
    
    try {
      ctClass.getDeclaredMethod("addClassFinderFirst").insertAfter(
          "{ " + 
          "  IntegrationFactory.getInstance().reinitializeClassLoader($0);" +
          "}");
    } catch (NotFoundException e) { /* skip */ }
    
    try {
      ctClass.getDeclaredMethod("close").insertAfter(
          "{ " + 
          "  IntegrationFactory.getInstance().reinitializeClassLoader($0);" +
          "}");
    } catch (NotFoundException e) { /* skip */ }
  }
}
